unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls;

type
  TOkno1 = class(TForm)
    HlMenu: TMainMenu;
    Soubor1: TMenuItem;
    Vstupn1: TMenuItem;
    Vstupn2: TMenuItem;
    Konec1: TMenuItem;
    Slovnk1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Vstupn1Click(Sender: TObject);
    procedure Vstupn2Click(Sender: TObject);
    procedure Tlac1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Okno1: TOkno1;
  Stitek1,Stitek2,Lin,Lout:TLabel;
  Tlac1:TButton;
  OpenDialog:TOpenDialog;
  OpRadek:TEdit;
  texty:TMemo;
  spatne:TListBox;

  fin,fout,slovnik:text;
  s_in,s_out:string;         //retzce pro nzvy soubor
  znak:char;                 //znak, kter uchovv mezery a teky
  veta:string;               //uchovv vtu;

implementation

procedure priprav_IN;
begin
  assign(fin, s_in);
  {$I-}
{  if( ioresult<>0 ) then
    ShowMessage('Chyba pi otevrn souboru')
  else}
    reset(fin);
  {$I+}
end;

procedure priprav_OUT;
begin
  assign(fout, s_out);
  {$I-}
{  if( ioresult<>0 ) then
    ShowMessage('Chyba pi otevrn souboru')
  else}
    rewrite(fout);
  {$I+}
end;

procedure priprav_slovnik;
begin
  assign(slovnik,'dict.txt');
  reset(slovnik);
end;

procedure priprav_soubory;
begin
  priprav_slovnik;
  priprav_IN;
  priprav_OUT;
end;

function nacti_slovo:string;
var slovo:string;
    c:char;
begin
  slovo:='';
  repeat
    read(fin,c);
    if( eof(fin) )then
    begin
      znak:=c;
      break;
    end;
    if( c<>#32) and (c<>'.') and (c<>',') and(c<>#10) and(c<>#13)  then
      slovo:=slovo+c
    else
      znak:=c;
  until (c=#32) or (c='.');
  nacti_slovo := slovo;
end;

function hledej_slovo:string;//hled slovo ve slovnku
var slovo:string;
    c:char;
begin
  slovo:='';
  repeat
    read(slovnik,c);
    if( c<>'/' ) then
      slovo:=slovo+c;
  until (c='/')or(eoln(slovnik));
  if( c='/' ) then
  begin
    while not eoln(slovnik) do
      read(slovnik,c);
    read(slovnik,c);
    read(slovnik,c);
  end;
  hledej_slovo := slovo;
end;

procedure hledej_chyby;
var slovo1:string; //slovo ve vstupnm souboru
    slovo2:string; //slovo ve slovnku;
    nalezeno:boolean;// bylo slovo nalezeno ve slovniku?
begin
  nalezeno := false;
  while not eof(fin) do
  begin
    slovo1 := nacti_slovo;
    while not eof(slovnik) do
    begin
      slovo2 := hledej_slovo;
      if( slovo1=slovo2 ) then
      begin
        nalezeno := true;
        break;
      end;
    end;
    reset(slovnik);
    if not nalezeno then
    begin
      write(fout,'#'+slovo1+znak);
      if( eoln(fin) ) then
        write(fout,#13#10);
    end
    else
    begin
      write(fout,slovo1+znak);
      if( eoln(fin) ) then
        write(fout,#13#10);
      nalezeno:=false;
    end;
  end;
  reset(fin);
end;

{$R *.DFM}

procedure TOkno1.FormCreate(Sender: TObject);
begin
  if( paramcount = 2) then
  begin
    s_in := paramstr(1);
    s_out := paramstr(2);
    priprav_soubory;
    hledej_chyby;
    closefile(fout);
    Application.Terminate;
  end
  else
    if( (paramcount <> 2)and(paramcount <> 0) ) then
    begin
      ShowMessage('Chyba : Pli mnoho nebo mlo parametr');
      Application.Terminate;
    end
    else
    begin
      priprav_slovnik;
      Stitek1 := TLabel.Create(Okno1);
      Stitek1.Left := 8;
      Stitek1.Top := 8;
      Stitek1.Width := 77;
      Stitek1.Height := 13;
      Stitek1.Caption := 'Vstupn soubor :';
      Stitek1.Parent := Okno1;

      Stitek2 := TLabel.Create(Okno1);
      Stitek2.Left := 8;
      Stitek2.Top := 32;
      Stitek2.Width := 82;
      Stitek2.Height := 13;
      Stitek2.Caption := 'Vstupn soubor :';
      Stitek2.Parent := Okno1;

      LIn := TLabel.Create(Okno1);
      LIn.Left := 104;
      LIn.Top := 8;
      LIn.Width := 3;
      LIn.Height := 13;
      LIn.Parent := Okno1;

      Lout := TLabel.Create(Okno1);
      Lout.Left := 104;
      Lout.Top := 32;
      Lout.Width := 3;
      Lout.Height := 13;
      Lout.Parent := Okno1;

      texty := TMemo.Create(Okno1);
      texty.Left := 8;
      texty.Top := 120;
      texty.Width := 329;
      texty.Height := 89;
      texty.TabOrder := 0;
      texty.Parent := Okno1;

      OpRadek := TEdit.Create(Okno1);
      OpRadek.Left := 344;
      OpRadek.Top := 120;
      OpRadek.Width := 121;
      OpRadek.Height := 21;
      OpRadek.TabOrder := 1;
      OpRadek.Parent := Okno1;

      Tlac1 := TButton.Create(Okno1);
      Tlac1.Left := 8;
      Tlac1.Top := 64;
      Tlac1.Width := 75;
      Tlac1.Height := 25;
      Tlac1.Enabled := False;
      Tlac1.Caption := 'Zkontroluj';
      Tlac1.TabOrder := 1;
      Tlac1.OnClick := Tlac1Click;
      Tlac1.Parent := Okno1;

      OpenDialog := TOpenDialog.Create(Okno1);
      OpenDialog.Filter := 'textov soubory|*.txt';

      spatne := TListBox.Create(Okno1);
      spatne.Left := 8;
      spatne.Top := 232;
      spatne.Width := 121;
      spatne.Height := 97;
      spatne.ItemHeight := 13;
      spatne.TabOrder := 0;
      spatne.Parent := Okno1;
    end;
end;

procedure TOkno1.Konec1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TOkno1.Vstupn1Click(Sender: TObject);
begin
  If( OpenDialog.Execute ) then
  begin
    s_IN := OpenDialog.FileName;
    Lin.caption := s_IN;
    Priprav_IN;
  end;
end;

procedure TOkno1.Vstupn2Click(Sender: TObject);
begin
  If( OpenDialog.Execute ) then
  begin
    s_OUT := OpenDialog.FileName;
    Lout.caption := s_OUT;
    Priprav_OUT;
  end;
  if( (s_IN<>'')and(s_OUT<>'') )then
    Tlac1.Enabled := true;
end;

procedure nacti_vetu;
var c:char;
    slovo1,slovo2:string;
    nalezeno :boolean;
begin
  nalezeno := false;
  veta:='';
  while (znak<>'.') do
  begin
    slovo1 := nacti_slovo;
    while not eof(slovnik) do
    begin
      slovo2 := hledej_slovo;
      if( slovo1=slovo2 ) then
      begin
        nalezeno := true;
        break;
      end;
    end;
    reset(slovnik);
    if not nalezeno then
    begin
      spatne.Items.Add(slovo1);
      texty.font.color:=clRed;
      texty.text:=texty.text+slovo1+znak;
      texty.font.color:=clBlack;
      if( eoln(fin) ) then
        write(fout,#13#10);
    end
    else
    begin
      texty.text:=texty.text+slovo1+znak;
      if( eoln(fin) ) then
        write(fout,#13#10);
      nalezeno:=false;
    end;
  end;
end;

procedure TOkno1.Tlac1Click(Sender: TObject);
var slovo1:string; //slovo ve vstupnm souboru
    slovo2:string; //slovo ve slovnku;
    nalezeno:boolean;// bylo slovo nalezeno ve slovniku?
begin
  nacti_vetu;
//  CloseFile(fout);
end;

end.
